
Public Class DataGridEx
    Inherits System.Windows.Forms.DataGrid

    Public Event CmdKeyEvent(ByVal keyData As System.Windows.Forms.Keys, ByRef Cancel As Boolean)
    Private AllowEdit_ As Boolean

    Protected Overrides Sub OnMouseMove( _
        ByVal e As System.Windows.Forms.MouseEventArgs)
        'swb_̋EɃ}EXƂ͉Ȃ
        Dim hti As System.Windows.Forms.DataGrid.HitTestInfo = _
            Me.HitTest(New System.Drawing.Point(e.X, e.Y))
        If hti.Type = _
            System.Windows.Forms.DataGrid.HitTestType.RowResize Then
            Return
        End If

        MyBase.OnMouseMove(e)
    End Sub

    Protected Overrides Sub OnMouseDown( _
        ByVal e As System.Windows.Forms.MouseEventArgs)
        'swb_̋EɃ}EXƂ͉Ȃ
        Dim hti As System.Windows.Forms.DataGrid.HitTestInfo = _
            Me.HitTest(New System.Drawing.Point(e.X, e.Y))
        If hti.Type = _
            System.Windows.Forms.DataGrid.HitTestType.RowResize Then
            Return
        End If

        MyBase.OnMouseDown(e)
    End Sub

    Protected Overrides Function ProcessCmdKey(ByRef msg As System.Windows.Forms.Message, ByVal keyData As System.Windows.Forms.Keys) As Boolean
        Dim blnCancel As Boolean
        Select Case keyData
            Case Keys.Return, Keys.Tab
                RaiseEvent CmdKeyEvent(keyData, blnCancel)
                If blnCancel Then
                    Return True
                End If
        End Select
        Return MyBase.ProcessCmdKey(msg, keyData)
    End Function

    Public Property AllowEdit() As Boolean
        Get
            Return AllowEdit_
        End Get
        Set(ByVal Value As Boolean)
            AllowEdit_ = Value
        End Set
    End Property

    Protected Overloads Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        If AllowEdit_ Then
        Else
            Dim nRow As Integer = Me.CurrentRowIndex
            If nRow >= 0 Then
                Me.Select(nRow)
            End If
        End If
        MyBase.OnPaint(pe)
    End Sub
End Class